import 'package:firebase_dart/firebase_core.dart';
import 'package:firebase_dart/firebase_dart.dart';
import 'package:jt_firebase/src/api/reference.dart';
import 'package:jt_firebase/src/fireblend/database.dart';

class JtDatabase extends FirebaseDatabase implements FireblendDatabase {
  static RegExp get endWithSlash => RegExp(r"(.*)/$");

  JtDatabase({FirebaseApp app, String databaseURL})
      : super(app: app ?? FirebaseApp.instance, databaseURL: databaseURL);

  factory JtDatabase.fromURL(String databaseURL) =>
      JtDatabase(databaseURL: databaseURL);

  @override
  FireblendDatabaseReference ref([String path]) {
    return JtDbReference(this.reference().child(path ?? '/'));
  }

  @override
  Future goOffline() {
    throw Exception('Not implemented!');
  }

  @override
  Future goOnline() {
    throw Exception('Not implemented!');
  }
}
