import 'package:firebase_dart/firebase_dart.dart';
import 'package:jt_firebase/src/api/data_snapshot.dart';
import 'package:jt_firebase/src/api/query.dart';
import 'package:jt_firebase/src/fireblend/database.dart';

class JtDbReference extends JtQuery implements FireblendDatabaseReference {
  Reference _ref;

  JtDbReference(this._ref) : super(_ref);

  @override
  String get key => this._ref.key;

  @override
  JtDbReference root() {
    return JtDbReference(this._ref.root);
  }

  @override
  JtDbReference child(String path) {
    return JtDbReference(this._ref.child(path));
  }

  @override
  JtDbReference parent() {
    return JtDbReference(this._ref.parent);
  }

  @override
  Future<JtDbReference> push([value]) async {
    return JtDbReference(await this._ref.push(value));
  }

  @override
  Future<Null> set(value, {priority}) {
    if (null == priority) {
      return this._ref.set(value);
    }
    return this._ref.setWithPriority(value, priority);
  }

  @override
  Future update(Map<String, dynamic> value) {
    return this._ref.update(value);
  }

  @override
  Future remove() {
    return this._ref.remove();
  }

  @override
  Future<dynamic> setPriority(priority) {
    return this._ref.setPriority(priority);
  }

  @override
  Future<JtDataSnapshot> transaction(Function function) async {
    return JtDataSnapshot(await this._ref.transaction(function));
  }

  @override
  FireblendOnDisconnect onDisconnect() {
    throw Exception('Not Implemented!');
  }
}
